Git development
 help / color / mirror / Atom feed
* [PATCH] Add contrib/stg-gitk: helper script to run gitk
@ 2007-01-08 22:12 Yann Dirson
  2007-01-09 10:02 ` Catalin Marinas
  0 siblings, 1 reply; 9+ messages in thread
From: Yann Dirson @ 2007-01-08 22:12 UTC (permalink / raw)
  To: Catalin Marinas; +Cc: GIT list




Signed-off-by: Yann Dirson <ydirson@altern.org>
---

Here is a small helper script implementing the display of current/named/all
stgit stacks (or standard branches) in gitk.  As noted earlier, that does not
allow to see new refs by requesting an update from gitk, but it will still be
useful to me at least :)

 contrib/stg-gitk |   59 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 59 insertions(+), 0 deletions(-)

diff --git a/contrib/stg-gitk b/contrib/stg-gitk
new file mode 100755
index 0000000..8d4ae43
--- /dev/null
+++ b/contrib/stg-gitk
@@ -0,0 +1,59 @@
+#!/bin/sh
+set -e
+
+# stg-gitk - helper script to graphically display an StGIT stack
+
+# Allows quick synchronization of a cvs mirror branch (does not try to
+# reconstruct patchsets, creates "jumbo" commits), and commits stgit
+# patches to CVS.
+
+# LIMITATIONS:
+# - asking gitk to "update" won't detect any new ref
+# - no support for spaces in branch names
+
+# Copyright (c) 2007 Yann Dirson <ydirson@altern.org>
+# Subject to the GNU GPL, version 2.
+
+usage()
+{
+    echo "Usage: $(basename $0) [<branches>|--all]"
+    exit 1
+}
+
+allbranches=0
+case "$1" in
+--all) allbranches=1; shift ;;
+--*) usage ;;
+*) break ;;
+esac
+
+if [ $allbranches = 1 ] && [ "$#" -gt 0 ]; then
+    usage
+fi
+
+GIT_DIR=$(git-rev-parse --git-dir)
+GIT_DIR_SPKIPLEN=$(printf "$GIT_DIR/X" | wc -c)
+
+refdirs=''
+if [ $allbranches = 1 ]; then
+    refdirs="$GIT_DIR/refs"
+else
+    if [ "$#" = 0 ]; then
+	set -- "$(stg branch)"
+    fi
+
+    for b in "$@"; do
+	if [ -e "$GIT_DIR/refs/patches/$b" ]; then
+	    # StGIT branch: show all patches
+	    refdirs="$refdirs $GIT_DIR/refs/patches/$b"
+	elif [ -e "$GIT_DIR/refs/heads/$b" ]; then
+	    # other GIT branch
+	    refdirs="$refdirs $GIT_DIR/refs/heads/$b"
+	else
+	    echo >&2 "ERROR: no such branch '$b'"
+	    usage
+	fi
+    done
+fi
+
+gitk $(find $refdirs -type f -not -name '*.log' | cut -c${GIT_DIR_SPKIPLEN}- )

^ permalink raw reply related	[flat|nested] 9+ messages in thread

end of thread, other threads:[~2007-01-12 23:09 UTC | newest]

Thread overview: 9+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2007-01-08 22:12 [PATCH] Add contrib/stg-gitk: helper script to run gitk Yann Dirson
2007-01-09 10:02 ` Catalin Marinas
2007-01-09 22:03   ` Yann Dirson
2007-01-10 10:34     ` Baz
2007-01-10 19:52     ` suggestions about stgit commands renaming Yann Dirson
2007-01-10 23:35       ` Catalin Marinas
2007-01-10 23:47     ` [PATCH] Add contrib/stg-gitk: helper script to run gitk Catalin Marinas
2007-01-12 22:47       ` Yann Dirson
2007-01-12 23:09         ` Catalin Marinas

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox